﻿unit Unit2;
{$MINSTACKSIZE 1025}//Minimum dieser Variable, sie muß größer als 1024 sein
//{$MAXSTACKSIZE 2048}//oder eben der obige Wert, wenn dieser angegeben wurde, scheint aber mit 1025 nicht zu funktionieren

{$mode objfpc}{$H+}{$DEFINE FPCMODUS}
//{$mode DELPHI}{$H+}{$DEFINE DELPHIMODUS} //Delphimodus nötig für Zuweisung einzelsortierelementverschiebe(x,SkipList.fWalker.ndKey)//war nötig in Lazarus 0.9.28.2

interface

uses
  Classes,
  SysUtils,
  //FileUtil,
  LResources,
  Forms
  , Controls
  , ExtCtrls
  //, Graphics
  , Dialogs
  , Windows
  //, jwaTLhelp32
  ;

type

  { TForm2 }

  TForm2 = class(TForm)
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure Tastendruck_Sortierungsabbruch_Formular2_endet(Sender: TObject; var Key: char);
    procedure MausUnten_Forumular2_endet(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Neuzeichnen_ausloesen(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure neuzeichnen;
    var _Width,_Height:word;
    function zentriert:boolean;
  end;

var
  Form2: TForm2;

implementation

uses unit1,Graphics;

procedure ereignis;
begin
if not pause then
  if sortierung_laeuft then abbruch:=true else
    begin
    //Form1.visible:=true;
    if Form2_Click_erlaubt and (Form1.CheckBox25.Checked or not Form1.visible or mischen_erlaubt)
    then mischen(true)
    else
    Form1.BringToFront;
    //SetForeGroundWindow(Form1.Handle);
    //BringWindowToTop(Form1.Handle)
    mischen_erlaubt:=false
    end
end;

{ TForm2 }

procedure TForm2.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
abbruch:=true;
Form1.Close
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
//visible:=true;//show
if Fileexists(IniFile.FileName) then
  begin
  width:=IniFile.ReadInteger('options','Form2.width',Form2.width);
  height:=IniFile.ReadInteger('options','Form2.height',Form2.height);
  left:=IniFile.ReadInteger('options','Form2.left',Form2.left);
  top:=IniFile.ReadInteger('options','Form2.top',Form2.top)
  end
else
  begin
  Width:=screen.width;
  Height:=screen.height;
  position:=poScreenCenter
  end;
maximale_Spaltenanzahl_im_Fenster:=clientWidth-Width_Zusatz;
maximale_Zeilenanzahl_im_Fenster:=clientHeight-Height_Zusatz;
Caption:=Form1.Button2.Caption;
mischen(true)
end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if sortierung_laeuft and (screen.Cursor=crNone) then
  begin
  Timer1.Enabled:=false;//damit das Intervall von neuem zu laufen beginnt
  Timer1.Enabled:=true;
  if Form1.RadioGroup2.ItemIndex=0 then screen.Cursor:=crDefault
  end
end;

procedure TForm2.FormResize(Sender: TObject);
var v:boolean;
begin
_Width:=ClientWidth+Width_Zusatz;_Height:=ClientHeight+Height_Zusatz;
if Form2_Click_erlaubt and (GetAsyncKeyState(VK_LBUTTON)<0) {and not sortierung_laeuft} then
  begin
  v:=clientHeight=Form1.SpinEdit3.Value;
  Form1.SpinEdit3.Value:=Form2.clientHeight;
  if Werteanzahl_mitlaufend or (Form1.SpinEdit7.Value>Form1.SpinEdit3.Value) then
    begin
    Form1.SpinEdit7.MaxValue:=Form1.SpinEdit3.MaxValue;
    Form1.SpinEdit7.Value:=Form1.SpinEdit3.Value
    end;
  //if not Form1.CheckBox28.Checked or Form1.CheckBox28.Checked and (Form2.ClientWidth<Form1.SpinEdit2.Value) then Form1.SpinEdit2.Value:=Form2.clientWidth;
  if not (Form1.CheckBox28.Enabled and Form1.CheckBox28.Checked) or (Form2.ClientWidth<Form1.SpinEdit2.Value) then Form1.SpinEdit2.Value:=Form2.clientWidth;//vereinfacht
  if v and (ClientWidth>Form1.SpinEdit2.Value)
  then neuzeichnen//Refresh
  else mischen(false)
  end
end;

procedure TForm2.Tastendruck_Sortierungsabbruch_Formular2_endet(Sender: TObject; var Key: char);
begin
{Bei OnKeyDown wird auch z.B. die Alt-Taste berücksichtigt->keine Umschaltung
zwischen den Programmen mit Alt+Tab möglich, ohne die Sortierung zu beenden}
//if GetAsyncKeyState(27)<>0 then //nur Druck auf ESC-Taste führt zum Abbruch
if key='-' then
  if Form1.SpinEdit1.value=0
  then Form1.SpinEdit1.value:=1
  else Form1.SpinEdit1.value:=Form1.SpinEdit1.value shl 1
else if key='+' then Form1.SpinEdit1.value:=Form1.SpinEdit1.value shr 1
     else if (upcase(key)='V') then
            //begin
            //Vergleichsanzeiger:=not Vergleichsanzeiger;
            Form1.CheckBox15.Checked:=not Form1.CheckBox15.Checked
            //end
          else if (upcase(key)='B') then Form1.CheckBox24.Checked:=not Form1.CheckBox24.Checked
               else if (upcase(key)='P') then
                      begin
                      neg(pause);
                      //Die nächsten beiden Zeilen verhindern die Anklickbarkeit von Form2, deshalb herausgenommen
                      //if screen.Cursor=crAppStart then screen.Cursor:=crHourGlass
                      //else if screen.Cursor=crHourGlass then screen.Cursor:=crAppStart
                      end
                    else ereignis
end;

procedure TForm2.MausUnten_Forumular2_endet(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
ereignis
end;

procedure TForm2.Neuzeichnen;
var Bitmap:TBitmap;

  procedure Bresenham(P1,P2:TPoint);//https://www.delphipraxis.net/32071-linien-plotten-mit-bresenham.html

    //procedure TauschePunkte(var P1,P2:TPoint);var Temp:TPoint;begin Temp:=P1;P1:=P2;P2:=Temp end;

    {procedure plot(x,y:word);
    begin
    Bitmap.Canvas.Pen.Color:=Ausgabefarbe(y);
    Bitmap.Canvas.MoveTo(x,pred(Form1.SpinEdit3.Value));
    Bitmap.Canvas.LineTo(x,Form1.SpinEdit3.Value-succ(abs(Menge[y].key)));//abs wegen negativer Werte beim O-Sort
    endpos[y]:=succ(x)
    end;}

  var dy,e:integer;
  x,y,dx:word;
  begin
  //if P1.X>P2.X then showmessage('Hoppla');//TauschePunkte(P1,P2);//hier nie erfüllt, da beide 0
  e:=0;//Der relative Fehler (im Tutorial e' genannt)
  //x:=P1.X;//? wird in der abgespeckten Algorithmusversion nie benutzt
  y:=P1.Y;
  dx:=P2.X-P1.X;
  dy:=P2.Y-P1.Y;
  if dy>=0 then//positive Steigung
    if dx>=dy
    then for x:=P1.X to P2.X do//leichte positive Steigung
      begin
      //Plot(x,y);
      Bitmap.Canvas.Pen.Color:=Ausgabefarbe(y);
      Bitmap.Canvas.MoveTo(x,pred(Form1.SpinEdit3.Value));
      Bitmap.Canvas.LineTo(x,Form1.SpinEdit3.Value-succ(abs(Menge[y].key)));//abs wegen negativer Werte beim O-Sort
      endpos[y]:=succ(x);
      if (e+dy) shl 1<dx
      then inc(e,dy)
      else
        begin
        inc(y);
        inc(e,dy-dx)
        end
      end
  //? wird nie benutzt
  {else
    begin
    for y:=P1.Y to P2.Y do//starke positive Steigung
      begin
      //Plot(x,y);
      Bitmap.Canvas.Pen.Color:=Ausgabefarbe(x);
      Bitmap.Canvas.MoveTo(y,pred(Form1.SpinEdit3.Value));
      Bitmap.Canvas.LineTo(y,Form1.SpinEdit3.Value-succ(abs(Menge[y].key)));//abs wegen negativer Werte beim O-Sort
      endpos[x]:=succ(y);
      if (e+dx) shl 1<dy
      then inc(e,dx)
      else
        begin
        inc(x);
        inc(e,dx-dy)
        end
      end
    end}
  {else//negative Steigung
    if dx>=-dy
    then for x:=P1.X to P2.X do// leichte negative Steigung
      begin
      //Plot(x,y);
      if (e+dy) shl 1>-dx
      then inc(e,dy)
      else
        begin
        dec(y);
        inc(e,dy+dx)
        end
      end
    else//starke negative Steigung
      begin
      //TauschePunkte(P1,P2);
      x:=P1.X;
      dx:=P2.X-P1.X;
      dy:=P2.Y-P1.Y;
      for y:=P1.Y to P2.Y do
        begin
        //Plot(x,y);
        if (e+dx) shl 1>-dy
        then inc(e,dx)
        else
          begin
          dec(x);
          inc(e,dx+dy)
          end
        end
      end}
  end;

//var l:word;
var P1,P2:TPoint;
begin
//if not Form1.CheckBox28.Enabled then ClientWidth:=Form1.SpinEdit2.Value;//stattdessen in Prozedur mischen
Bitmap:=TBitmap.Create;
if Form1.RadioGroup1.ItemIndex=0 then Bitmap.Canvas.Brush.Color:=clWhite else Bitmap.Canvas.Brush.Color:=clBlack;
Bitmap.Height:=ClientHeight;
Bitmap.Width:=ClientWidth;
Bitmap.Canvas.FillRect(0,0,ClientWidth,ClientHeight);
{for l:=0 to pred(Form1.SpinEdit2.Value) do
  begin
  Bitmap.Canvas.Pen.Color:=Ausgabefarbe(l);
  Bitmap.Canvas.MoveTo(l,pred(Form1.SpinEdit3.Value));
  Bitmap.Canvas.LineTo(l,Form1.SpinEdit3.Value-succ(abs(Menge[l].key)))//abs wegen negativer Werte beim O-Sort
  end;}

P1.x:=0;P1.y:=0;
P2.x:=pred(ClientWidth);
P2.y:=pred(Form1.SpinEdit2.Value);
Bresenham(P1,P2);
endpos[Form1.SpinEdit2.Value]:=Form2.Width;//statt immer in der Prozedur "linie_zeichnen" abzufragen
canvas.Draw(0,0,bitmap);
Bitmap.Free;
Form1.BringToFront//Form1 ist beim Compilat von Lazarus 1.6.4 nicht im Vordergrund, wenn es nach dem Minimieren wieder normalisiert wird, deshalb dieser Befehl
//SetForeGroundWindow(Form1.Handle);
//SetWindowPos(Form1.Handle,HWND_TOPMOST,Left,Top,Width,Height,SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);//nach dem Minimieren und Wiederherstellen hat Form1 den Fokus verloren
//BringWindowToTop(Form1.Handle)
end;

procedure TForm2.Neuzeichnen_ausloesen(Sender: TObject);begin neuzeichnen end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
if sortierung_laeuft then
  begin
  GetCursorPos(CursorPos);
  if Form1.RadioGroup2.ItemIndex=0 then screen.Cursor:=crNone;
  Timer1.Enabled:=false
  end
end;

function TForm2.zentriert:boolean;
begin
if BorderStyle=bsNone
then result:=true//(abs(screen.width-2*Form2.Left-Form2.ClientWidth)<2) and (abs(screen.height-2*Form2.Top-Form2.ClientHeight)<2)
else result:=(abs(screen.width-2*Form2.Left-Form2._Width)<2) and (abs(screen.height-2*Form2.Top-Form2._Height)<2)
end;

initialization
  {$I unit2.lrs}

end.
